SystemOrganization addCategory: #CardThing!

WAComponent subclass: #CTCardComponent
	instanceVariableNames: 'card'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing'!

!CTCardComponent class methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 20:40'!
for: aCard
	^self basicNew 
	initializeWithCard: aCard;
	yourself ! !

!CTCardComponent methodsFor: 'actions' stamp: 'Caitlin 8/31/2012 22:34'!
editCard 
	self call: (CTCardEditor card: card)! !

!CTCardComponent methodsFor: 'initialization' stamp: 'Caitlin 8/31/2012 20:41'!
initializeWithCard: aCard
	self initialize.
	card := aCard! !

!CTCardComponent methodsFor: 'rendering' stamp: 'Caitlin 8/31/2012 23:21'!
renderContentOn: html
	html div: [
	html anchor callback: [self editCard]; with: card name. html break.
	html strong: 'Grade: '; render: card grade. html break.
	card trigger ifNotNil: [html strong: 'Trigger: '; render: card trigger triggerName. html break.].
	card shield ifNotNil: [html strong: 'Shield: '; render: card shield. html break.].
	html strong: 'Power: '; render: card damage. html break.
	card picture ifNotNil: [html image url: (WAFileLibrary / ('uploads/', card picture))].
	
	]
	! !

WAComponent subclass: #CTCardEditor
	instanceVariableNames: 'card'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing'!

!CTCardEditor class methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 21:12'!
card: aCard
	 ^self basicNew 
		initializeWithCard: aCard;
		yourself.! !

!CTCardEditor class methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 21:14'!
new
	 ^self basicNew 
		initializeWithCard: CTCard new;
		yourself.! !

!CTCardEditor methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 21:17'!
initializeWithCard: aCard
	self initialize.
	card := aCard! !

!CTCardEditor methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 23:06'!
renderContentOn: html
	html form multipart; with: [
		html div: [html label for: #name; with: 'Name:'.
			html textInput on: #name of: card; id: #name].
		html div: [html label for: #grade; with: 'Grade:'.
			html textInput on: #grade of: card; id: #grade].
		html div: [html label for: #trigger; with: 'Trigger:'.
			html select beOptional; labels: [ :t | t triggerName ]; list: (CTTrigger triggers); on: #trigger of: card; id: #trigger].
		html div: [html label for: #shield; with: 'Shield:'.
			html textInput on: #shield of: card; id: #shield].
		html div: [html label for: #damage; with: 'Power:'.
			html textInput on: #damage of: card; id: #damage].
		html div: [html label for: #picture; with: 'Picture:'.
			html fileUpload callback: [ :p | self setPicture: p]; id: #picture].
		html div: [html submitButton callback: [self saveAndAnswer]; value: 'Save']]! !

!CTCardEditor methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 21:24'!
saveAndAnswer 
	self answer: card! !

!CTCardEditor methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 23:22'!
setPicture: aFile
    | stream fileName |
	fileName := UUID new printString.
    stream := (FileDirectory default directoryNamed: 'WAFileLibrary/uploads')
        assureExistence;
        forceNewFileNamed: fileName.
    [ stream binary; nextPutAll: aFile rawContents ] 
        ensure: [ stream close ].
	card picture: fileName.! !

WAComponent subclass: #CTCardList
	instanceVariableNames: 'cards'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing'!

!CTCardList class methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 20:33'!
cards: aCollection
	^self basicNew 
		initializeWithCards: aCollection;
		yourself ! !

!CTCardList methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 22:32'!
initializeWithCards: aCollection
	self initialize.
	cards := (aCollection collect: [ :c | CTCardComponent for: c])! !

!CTCardList methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 20:50'!
renderContentOn: html
	html unorderedList: [
		cards do: [ :c | html listItem: c ]]! !

WAComponent subclass: #CTRoot
	instanceVariableNames: 'cardList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing'!

!CTRoot class methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 19:50'!
canBeRoot 
^true! !

!CTRoot methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 21:40'!
addCard 
	| card |
	card := self call: CTCardEditor new.
	CTCard addCard: card.
	self resetCards ! !

!CTRoot methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 21:40'!
initialize 
	super initialize.
	self resetCards! !

!CTRoot methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 20:54'!
renderContentOn: html
	html anchor callback: [self addCard]; with: 'Add Card'.
	html render: cardList! !

!CTRoot methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 21:40'!
resetCards 
	cardList := CTCardList cards: CTCard cards! !

Object subclass: #CTCard
	instanceVariableNames: 'picture name damage grade trigger effects shield'
	classVariableNames: 'AllCards'
	poolDictionaries: ''
	category: 'CardThing'!

!CTCard class methodsFor: 'instance creation' stamp: 'Caitlin 8/31/2012 21:34'!
addCard: aCard
	self cards add: aCard! !

!CTCard class methodsFor: 'instance creation' stamp: 'Caitlin 8/31/2012 21:37'!
cards
	^AllCards ifNil: [AllCards := {CTCard new name: 'Card1'; yourself.
	CTCard new name: 'Card2'; yourself.
	CTCard new name: 'Card3'; yourself.} asOrderedCollection ]! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:17'!
addEffect: anEffect
	effects add: anEffect
! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:05'!
damage
	^damage! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:04'!
damage: aNumber
	damage := aNumber! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:13'!
effects
	^effects! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:07'!
grade
	^grade! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 22:26'!
grade: aNumberOrString
	| n |
	n := aNumberOrString asNumber.
	(n between: 0 and: 3) ifFalse: [self error: 'Must be between 0 and 3'].
	grade := n.! !

!CTCard methodsFor: 'initialization' stamp: 'Caitlin 8/31/2012 22:20'!
initialize 
	super initialize.
	effects := OrderedCollection new.
	grade := 0
	! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:03'!
name
	^name! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:03'!
name: aName
	name := aName! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:10'!
picture
	^picture! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:11'!
picture: aPicture
	picture := aPicture! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:15'!
removeEffect: anEffect
	effects remove: anEffect
	! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:10'!
shield
	^shield! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:10'!
shield: aNumber
	shield := aNumber! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:08'!
trigger
	^trigger! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:09'!
trigger: aNumber
	trigger := aNumber! !

Object subclass: #CTTrigger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing'!

CTTrigger subclass: #CTCriticalTrigger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing'!

!CTCriticalTrigger class methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 22:46'!
triggerName
	^ 'Critical'! !

CTTrigger subclass: #CTDrawTrigger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing'!

!CTDrawTrigger class methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 22:45'!
triggerName
	^ 'Draw'! !

CTTrigger subclass: #CTHealTrigger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing'!

!CTHealTrigger class methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 22:46'!
triggerName
	^ 'Heal'! !

CTTrigger subclass: #CTStandTrigger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing'!

!CTStandTrigger class methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 22:46'!
triggerName
	^ 'Stand'! !

!CTTrigger class methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 22:48'!
triggers
	^ self subclasses! !

!CTTrigger methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 22:44'!
name
	^self class triggerName! !
